# CoverageThresholdTask

Extends \Task

Stops the build if any of the specified coverage threshold was not reached

Use \Project#createTask to register a new Task.

author | Benjamin Schultz bschultz@proqrent.de
version | $Id: f0493a1c73d53a96c2cbe8f6ad074df435a4e3e7 $
package | phing.tasks.ext.coverage
since | 2.4.1

### Methods

## Calculates the coverage threshold

    calculateCoverageThreshold(string $filename, array $coverageInformation)

throws |

### Arguments

#### $filename

`string`

The filename to analyse

#### $coverageInformation

`array`

Array with coverage information

## Create classpath object

    createClasspath() : \Path

### Response

`\Path`

## Create excludes object

    createExcludes() : \Excludes

### Response

`\Excludes`

## Filter covered statements

    filterCovered(integer $var) : boolean

### Arguments

#### $var

`integer`

Coverage CODE/count

### Response

`boolean`

## Returns the textual description of the task

    getDescription() : string

inherited

### Response

`string`

The text description of the task

## Returns the location within the buildfile this task occurs. Used by {@link BuildException} to give detailed error messages.

    getLocation() : \Location

inherited

### Response

`\Location`

The location object describing the position of this task within the buildfile.

## Returns the owning target of this task.

    getOwningTarget() : \Target

inherited

### Response

`\Target`

The target object that owns this task

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Returns a name

    getRegisterSlot(string $slotName) : \RegisterSlot

inherited

### Arguments

#### $slotName

`string`

### Response

`\RegisterSlot`

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

inherited

### Response

`\RuntimeConfigurable`

The wrapper object used by this task

## Returns the name of task, used only for log messages

    getTaskName() : string

inherited

### Response

`string`

Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

inherited

### Response

`string`

The type of this task (XML Tag)

## Called by the parser to let the task initialize properly.

    init()

inherited

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

throws |

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Called by the project to let the task do it's work. This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running <em>phing target1 target2</em> will run all tasks in target3 twice.

    main()

inherited abstract

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

## Configure this task if it hasn't been done already.

    maybeConfigure()

inherited

## Perfrom this task

    perform()

inherited

throws |

## Sets an optional classpath

    setClasspath(\Path $classpath)

### Arguments

#### $classpath

`\Path`

The classpath

## Sets the optional coverage database to use

    setDatabase(\PhingFile $database)

### Arguments

#### $database

`\PhingFile`

## Sets a textual description of the task

    setDescription(string $desc)

inherited

### Arguments

#### $desc

`string`

The text describing the task

## Sets the location within the buildfile this task occurs. Called by the parser to set location information.

    setLocation(\Location $location)

inherited

### Arguments

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

inherited

### Arguments

#### $target

`\Target`

## Sets the coverage threshold for any class

    setPerClass(integer $threshold)

### Arguments

#### $threshold

`integer`

Coverage threshold for any class

## Sets the coverage threshold for any method

    setPerMethod(integer $threshold)

### Arguments

#### $threshold

`integer`

Coverage threshold for any method

## Sets the coverage threshold for entire project

    setPerProject(integer $threshold)

### Arguments

#### $threshold

`integer`

Coverage threshold for entire project

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

inherited

### Arguments

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## Sets the name of this task for log messages

    setTaskName(string $name) : string

inherited

### Arguments

#### $name

`string`

### Response

`string`

A string representing the name of this task for log

## Sets the type of the task. Usually this is the name of the XML tag

    setTaskType( $name)

inherited

### Arguments

#### $name

``

## Sets whether to enable detailed logging or not

    setVerbose(boolean $verbose)

### Arguments

#### $verbose

`boolean`

### Properties

## Holds an optional classpath

    _classpath : \Path

var |

### Type(s)

`\Path`

## Holds the exclusions

    _excludes : \Excludes

var |

### Type(s)

`\Excludes`

## Holds an optional database file

    _database : \PhingFile

var |

### Type(s)

`\PhingFile`

## Holds the coverage threshold for the entire project

    _perProject : integer

var |

### Type(s)

`integer`

## Holds the coverage threshold for any class

    _perClass : integer

var |

### Type(s)

`integer`

## Holds the coverage threshold for any method

    _perMethod : integer

var |

### Type(s)

`integer`

## Holds the minimum found coverage value for a class

    _minClassCoverageFound : integer

var |

### Type(s)

`integer`

## Holds the minimum found coverage value for a method

    _minMethodCoverageFound : integer

var |

### Type(s)

`integer`

## Number of statements in the entire project

    _projectStatementCount : integer

var |

### Type(s)

`integer`

## Number of covered statements in the entire project

    _projectStatementsCovered : integer

var |

### Type(s)

`integer`

## Whether to enable detailed logging

    _verbose : boolean

var |

### Type(s)

`boolean`

## Owning Target object

    target : \Target

inherited

var |

### Type(s)

`\Target`

## Description of the task

    description : string

inherited

var |

### Type(s)

`string`

## Internal taskname (req)

    taskType : string

inherited

var |

### Type(s)

`string`

## Taskname for logger

    taskName : string

inherited

var |

### Type(s)

`string`

## Stored buildfile location

    location : \Location

inherited

var |

### Type(s)

`\Location`

## Wrapper of the task

    wrapper : \RuntimeConfigurable

inherited

var |

### Type(s)

`\RuntimeConfigurable`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`